<%@ LANGUAGE="VBScript" %>

<% '***************************************************************************
   '* Football Pool                                                           *
   '*                                                                         *
   '* Copyright 2000 by Mike Hall                                             *
   '* Web address: http://www.brainjar.com                                    *
   '*                                                                         *
   '* Use permitted provided this notice remains intact. Any sale or redis-   *
   '* tribution without prior consent is prohibited.                          *
   '***************************************************************************
%>

<!-- #include file="protect.inc" -->
<!-- #include file="common.inc" -->
<!-- #include file="header.inc" -->

<% 'Open the database.

   call OpenDB()

   'Default to current week if no valid number was given.

   week = Request("week")
   if not IsNumeric(week) then
     week = CurrentWeek()
   else
     week = Round(week)
     if week < 1 or week > NumberOfWeeks() then
       week = CurrentWeek()
     end if
   end if

   'Initialize global lock out variable.

   dateNow = CurrentDateTime()
   allLocked = false

   'Create an array of game objects

   dim games
   n = NumberOfGames(week)
   redim games(n - 1)

   sql = "select Schedule.*," _
      & " Teams.City as VCity, Teams.Name as VName, Teams.DisplayName as VDisplayName," _
      & " Teams2.City as HCity, Teams2.Name as HName, Teams2.DisplayName as HDisplayName" _
      & " from (Schedule inner join Teams on Schedule.VisitorID = Teams.TeamID)" _
      & " inner join Teams as Teams2 on Schedule.HomeID = Teams2.TeamID" _
      & " where Schedule.Week = " & week _
      & " order by Schedule.Date, Schedule.Time, Teams.City, Teams.Name"
   set rs = DbConn.Execute(sql)
   if not (rs.BOF and rs.EOF) then
     i = 0
     do while not rs.EOF
       set games(i) = GameObj(rs)
       i = i + 1
       rs.MoveNext
     loop
   end if

   'If there's form data, check it.

   errorFlag = false
   if Request.ServerVariables("Content_Length") > 0 then
     tb = Request.Form("tb")

     'Administrator may not make entries.

     if Session("PoolUsername") = ADMIN_USERNAME then
       call ErrorMessage("User '" & ADMIN_USERNAME & "' may not enter picks.")
       errorFlag = true

     'If all games locked, no changes allowed.

     elseif allLocked then
       call ErrorMessage("All games for this week have been locked out, changes not accepted.")
       errorFlag = true

     'Check tie breaker value.

     else
       if tb = "" then
         call ErrorMessage("You must enter a point total for the tie breaker, changes not accepted.")
         errorFlag = true
       elseif not IsNumeric(tb) then
         call ErrorMessage("Tie breaker point total must be numeric, changes not accepted.")
         errorFlag = true
       elseif tb < 0 or CDbl(tb) <> Round(CDbl(tb)) then
         call ErrorMessage("Invalid tie breaker point value, changes not accepted.")
         errorFlag = true
       end if
     end if

     'Check for picks in locked out games

     if not allLocked then
       anyLocked = false
       for i = 0 to UBound(games)
         if Request.Form("pick-" & games(i)("id")) <> "" and games(i)("locked") then
           call ErrorMessage(games(i)("visitorName") & " at " & games(i)("homeName") & " has been locked, this change not accepted.")
           errorFlag = true
           anyLocked = true
         end if
       next
       if anyLocked then
         call ErrorMessage("Please resubmit to update remaining picks.")
       end if
     end if

     'If there were no errors, process the data and redirect the user to the
     'results page.

     if not errorFlag then
       for i = 0 to UBound(games)
         pick = Request.Form("pick-" & games(i)("id"))
         if pick = "" then
           pick = GetPick(games(i)("id"))
         end if
         sql = "delete from Picks" _
            & " where Username = '" & Session("PoolUsername") & "'" _
            & " and GameID = " & games(i)("id")
         set rs = DbConn.Execute(sql)
         sql = "insert into Picks" _
            & " (Username, GameID, Pick)" _
            & " values('" & Session("PoolUsername") & "'," _
            & " '" & games(i)("id") & "', " _
            & " '" & pick & "')"
         set rs = DbConn.Execute(sql)
       next
       if tb <> "" then
         sql = "delete from TieBreaker" _
            & " where Week = " & week _
            & " and Username = '" & Session("PoolUsername") & "'"
         set rs = DbConn.Execute(sql)   
         sql = "insert into TieBreaker" _
            & " (Week, Username, TBPoints)" _
            & " values(" & week & ", '" & Session("PoolUsername") & "'," _
            & " " & tb & ")"
         set rs = DbConn.Execute(sql)
       end if
       Response.Redirect("results.asp?week=" & week)
     end if

   end if

   'Build the form. %>

<form action="<% = Request.ServerVariables("SCRIPT_NAME") %>" method="post">
<input name="week" type="hidden" value="<% = week %>">
<table bgcolor="#000066" border=0 cellpadding=1 cellspacing=0><tr><td>
<table bgcolor="#ffffff" border=0 cellpadding=3 cellspacing=0 width="100%">
<tr><th colspan=9>Week <% = week %></th></tr>
<% for i = 0 to UBound(games)
     if Round(i / 2) * 2 = i then %>
<tr align=right>
<%   else %>
<tr align=right class="alt">
<%   end if %>
  <td><% = WeekdayName(Weekday(games(i)("date")), true) %>&nbsp;</td>
  <td><% = FormatDate(games(i)("date")) %>&nbsp;</td>
  <td><% = FormatTime(games(i)("date")) %>&nbsp;</td>

<%   'If no pick was given for this game or the game is locked, check the
     'database for an existing value.

      pick = Request.Form("pick-" & games(i)("id"))
      if pick = "" or games(i)("locked") then
        pick = GetPick(games(i)("id"))
      end if

     if games(i)("locked") then
       visitor = games(i)("visitorName")
       home = games(i)("homeName")
       tie = "&nbsp;"
       if pick = games(i)("visitorID") then
         visitor = "<b>" & visitor & "</b>"
       elseif pick = games(i)("homeID") then
         home = "<b>" & home & "</b>"
       elseif pick = "Tie" then
         tie = "<b>Tie</b>"
       end if %>
  <td><% = visitor %>&nbsp;</td>
  <td>&nbsp;</td>
  <td>at <% = home %>&nbsp;</td>
  <td>&nbsp;</td>
  <td><% = tie %></td>
  <td>&nbsp;</td>
<%   else %>
  <td><% = games(i)("visitorName") %>&nbsp;</td>
  <td><input name="pick-<% = games(i)("id") %>" type="radio" value="<% = games(i)("visitorID") %>" <% = IsChecked(pick, games(i)("visitorID")) %>></td>
  <td>at <% = games(i)("homeName") %>&nbsp;</td>
  <td><input name="pick-<% = games(i)("id") %>" type="radio" value="<% = games(i)("homeID") %>" <% = IsChecked(pick, games(i)("homeID")) %>></td>
  <td>Tie</td>
  <td><input name="pick-<% = games(i)("id") %>" type="radio" value="Tie" <% = IsChecked(pick, "Tie") %>></td>
<%   end if %>
</tr>
<% next %>
<tr><th colspan=9>Tie Breaker</th></tr>
<tr>
  <td align=right colspan=9>
  Total points in the Monday Night Football game:

<% 'If no tie breaker points were given or all games have been locked, check
   'the database for an existing value.

   if tb = "" or allLocked then
     tb = UserTBGuess(Session("PoolUsername"), week)
   end if
   if allLocked then %>
  <b><% = tb %><b>
<% else %>
  <input name="tb" type="text" value="<% = tb %>" size=2>
<% end if %>
  </td>
</tr>
</table>
</td></tr></table>
<p>
<input type="submit" value="Submit">
</form>
<p>
<% str = OpenDates(week)
   if str <> "" then %>
<span class="default">
<b>Open Dates:</b> <% = str %>
</span>
<p>
<% end if %>

<% 'List remaining weeks %>
<span class="default">
<% n = NumberOfWeeks()
   week = CurrentWeek()
   if week <> n then %>
<b>Go to week:</b>&nbsp;
<%   for i = week to NumberOfWeeks() %>
<a href="<% = Request.ServerVariables("SCRIPT_NAME") %>?week=<% = i %>">
<% = i %></a>&nbsp;
<%   next
   end if %>
</span>

<!-- #include file="footer.inc" -->

<% '***************************************************************************
   '* Local functions and subroutines.                                              *
   '***************************************************************************

   '---------------------------------------------------------------------------
   ' GameObj(gameid): Creates a dictionary object to hold data for a single
   ' game.
   '---------------------------------------------------------------------------

   function GameObj(rs)

     dim game

     set game = Server.CreateObject("Scripting.Dictionary")

     'Copy record set data.

     game.Add "id",          rs.Fields("GameID").Value
     game.Add "date",        CDate(rs.Fields("Date").Value & " " & rs.Fields("Time").Value)
     game.Add "visitorID",   rs.Fields("VisitorID").Value
     game.Add "visitorName", rs.Fields("VCity").Value
     game.Add "homeID",      rs.Fields("HomeID").Value
     game.Add "homeName",    rs.Fields("HCity").Value
     if rs.Fields("VDisplayName").Value <> "" then
       game("visitorName") = rs.Fields("VDisplayName").Value
     end if
     if rs.Fields("HDisplayName").Value <> "" then
       game("homeName") = rs.Fields("HDisplayName").Value
     end if
     game.Add "locked", false

     'Determine game lock out status. If this is a Sunday game and we're past
     'its start time, set the lock all flag.

     if Weekday(game("date")) = vbSunday and game("date") <= dateNow then
       allLocked = true
     end if
     if allLocked or game("date") <= dateNow then
       game("locked") = true
     else
       game("locked") = false
     end if

     'Return game object.

     set GameObj = game

   end function

   '---------------------------------------------------------------------------
   ' GetPick(id): Find this user's current pick for the given game. Returns a
   ' null string if no pick is found in the database.
   '---------------------------------------------------------------------------

   function GetPick(id)

     dim sql, rs

     GetPick = ""
     sql = "select Pick from Picks" _
        & " where Username = '" & Session("PoolUsername") & "'" _
        & " and GameID = " & id
     set rs = DbConn.Execute(sql)
     if not (rs.BOF and rs.EOF) then
       GetPick = rs.Fields("Pick").Value
     end if

   end function

   '---------------------------------------------------------------------------
   ' IsChecked(v1, v2): Used to set a radio button checked parameter if the
   ' values given are equal.
   '---------------------------------------------------------------------------

   function IsChecked(v1, v2)

     IsChecked = ""
     if v1 = v2 then
       IsChecked = " checked"
     end if

   end function %>
