<%@ LANGUAGE="VBScript" %>

<% '***************************************************************************
   '* Football Pool                                                           *
   '*                                                                         *
   '* Copyright 2000 by Mike Hall                                             *
   '* Web address: http://www.brainjar.com                                    *
   '*                                                                         *
   '* Use permitted provided this notice remains intact. Any sale or redis-   *
   '* tribution without prior consent is prohibited.                          *
   '***************************************************************************
%>

<!-- #include file="protect.inc" -->
<!-- #include file="common.inc" -->
<!-- #include file="header.inc" -->

<% 'Tie breaker constants.

   Const TIE_BREAKER_DEBUG_ON = false
   Const TIE_BREAKER_MIN_WEEK = 6

   'Set up conference and division names.

   conferences = Array("AFC", "NFC")
   divisions   = Array("East", "Central", "West")

   'Open the database.

   call OpenDB()

   'Get list of teams and data ordered by conference and division.

   dim teams
   n = NumberOfTeams()
   redim teams(n - 1)

   i = 0
   sql = "select * from Teams order by Conference, Division, City, Name"
   set rs = DbConn.Execute(sql)
   if not (rs.BOF and rs.EOF) then
     do while not rs.EOF
       set teams(i) = TeamObj(rs.Fields("TeamID").Value)
       i = i + 1
       rs.MoveNext
     loop
    end if

   'Sort teams within each division.

   div = teams(0)("division")
   m = 0
   for i = 0 to UBound(teams)
     if teams(i)("division") <> div then
       call SortTeams(m, i - 1)
       div = teams(i)("division")
       m = i
     end if
   next
   call SortTeams(m, i - 1) %>

<table bgcolor="#000066" border=0 cellpadding=1 cellspacing=0><tr><td>
<table bgcolor="#ffffff" border=0 cellpadding=3 cellspacing=0 width="100%">
<% div = 0
   for i = 0 to n - 1
     if div <> teams(i)("division") then
       n = 0
       div = teams(i)("division")
       if teams(i)("conference") = 1 then
         styleClass = "afc"
       else
         styleClass = "nfc"
       end if %>
<tr align=right>
  <th align=left class="<% = styleClass %>"><% = conferences(teams(i)("conference") - 1) & " " & divisions(div - 1) %></th>
  <th class="<% = styleClass %>">W</th>
  <th class="<% = styleClass %>">L</th>
  <th class="<% = styleClass %>">T</th>
  <th class="<% = styleClass %>">Pct</th>
  <th class="<% = styleClass %>">PF</th>
  <th class="<% = styleClass %>">PA</th>
  <th class="<% = styleClass %>">Home</th>
  <th class="<% = styleClass %>">Road</th>
  <th class="<% = styleClass %>">AFC</th>
  <th class="<% = styleClass %>">NFC</th>
  <th class="<% = styleClass %>">Div</th>
  <th class="<% = styleClass %>">Strk</th>
</tr>
<%   end if
     if Round(n / 2) * 2 = n then %>
<tr align=right>
<%   else %>
<tr align=right class="alt">
<%   end if %>
  <td align=left>
  <b><a href="team.asp?id=<% = teams(i)("id") %>"><% = teams(i)("name") %></a></b>
  </td>
  <td>&nbsp;<% = teams(i)("won") %></td>
  <td>&nbsp;<% = teams(i)("lost") %></td>
  <td>&nbsp;<% = teams(i)("tied") %></td>
  <td>&nbsp;<% = teams(i)("pct") %></td>
  <td>&nbsp;<% = teams(i)("pf") %></td>
  <td>&nbsp;<% = teams(i)("pa") %></td>
  <td>&nbsp;<% = teams(i)("home") %></td>
  <td>&nbsp;<% = teams(i)("road") %></td>
  <td>&nbsp;<% = teams(i)("afc") %></td>
  <td>&nbsp;<% = teams(i)("nfc") %></td>
  <td>&nbsp;<% = teams(i)("div") %></td>
  <td>&nbsp;<% = teams(i)("strk") %></td>
</tr>
<%   'Output debug information for testing tie breaker results.

     if TIE_BREAKER_DEBUG_ON and teams(i)("tb") <> "" then
       if Round(n / 2) * 2 = n then %>
<tr align=right>
<%     else %>
<tr align=right class="alt">
<%     end if %>
  <td align=left colspan=13><font face="MS Sans Serif,Arial,Helvetica" size=1>
  Note: <% = teams(i)("tb") %>
  </td>
</tr>
<%   end if
     n = n + 1
   next %>
</table>
</td></tr></table>

<!-- #include file="footer.inc" -->

<% '***************************************************************************
   '* Local functions and subroutines.                                              *
   '***************************************************************************

   '---------------------------------------------------------------------------
   ' NumberOfTeams(): Returns the total number of teams in the database.
   '---------------------------------------------------------------------------

   function NumberOfTeams()

     dim sql, rs

     NumberOfTeams = 0
     sql = "select count(TeamID) as total from Teams"
     set rs = DbConn.Execute(sql)
     if not (rs.BOF and rs.EOF) then
       NumberOfTeams = rs.Fields("total").Value
     end if

   end function

   '---------------------------------------------------------------------------
   ' TeamObj(id): Creates a dictionary object to hold data for a single team
   ' given by 'id'.
   '---------------------------------------------------------------------------

   function TeamObj(id)

     dim sql, rs
     dim team
     dim n, done
     dim pf, pa, w, l, t, pct
     dim home, road, afc, nfc, div, strk
     dim opp
     dim homew, homel, homet, roadw, roadl, roadt
     dim afcw, afcl, afct, nfcw, nfcl, nfct
     dim divw, divl, divt
     dim oppw, oppl, oppt
     dim netd

     set team = Server.CreateObject("Scripting.Dictionary")

     'Get team conference, division and name.

     sql = "select * from Teams where TeamID = '" & id & "'"
     set rs = DbConn.Execute(sql)
     if not (rs.BOF and rs.EOF) then
       team.Add "id", rs.Fields("TeamID").Value
       team.Add "conference", rs.Fields("Conference").Value
       team.Add "division", rs.Fields("Division").Value
       if rs.Fields("DisplayName") <> "" then
         team.Add "name", rs.Fields("DisplayName").Value
       else
         team.Add "name", rs.Fields("City").Value
       end if
     end if

     'Find records and points.

     n     = 0
     pf    = 0
     pa    = 0
     w     = 0
     l     = 0
     t     = 0
     pct   = 0
     homew = 0
     homel = 0
     homet = 0
     roadw = 0
     roadl = 0
     roadt = 0
     afcw  = 0
     afcl  = 0
     afct  = 0
     nfcw  = 0
     nfcl  = 0
     nfct  = 0
     divw  = 0
     divl  = 0
     divt  = 0
     oppw  = Array()
     oppl  = Array()
     oppt  = Array()
     netd  = 0

     sql = "select * from Teams, Schedule" _
        & " where Result <> ''" _
        & " and" _
        & " ((VisitorID = '" & id & "' and TeamID = HomeID)" _
        & "  or" _
        & "  (HomeID    = '" & id & "' and TeamID = VisitorID))"
     set rs = DbConn.Execute(sql)
     if not (rs.BOF and rs.EOF) then
       do while not rs.EOF
         if rs.Fields("HomeID").Value = id then
           opp = rs.Fields("VisitorID").Value
         else
           opp = rs.Fields("HomeID").Value
         end if
         if rs.Fields("Result").Value = id then
           w = w + 1
           call AddOpponent(oppw, opp)
           if rs.Fields("HomeID").Value = id then
             homew = homew + 1
           else
             roadw = roadw + 1
           end if
           if rs.Fields("Conference").Value = 1 then
             afcw = afcw + 1
           else
             nfcw = nfcw + 1
           end if
           if rs.Fields("Conference").Value = team("conference") and _
              rs.Fields("Division").Value = team("division") then
             divw = divw + 1
           end if
         elseif rs.Fields("Result").Value = "Tie" then
           t = t + 1
           call AddOpponent(oppt, opp)
           if rs.Fields("HomeID").Value = id then
             homet= homet + 1
           else
             roadt = roadt + 1
           end if
           if rs.Fields("Conference").Value = 1 then
             afct = afct + 1
           else
             nfct = nfct + 1
           end if
           if rs.Fields("Conference").Value = team("conference") and _
              rs.Fields("Division").Value = team("division") then
             divt = divt + 1
           end if
         else
           l = l + 1
           call AddOpponent(oppl, opp)
           if rs.Fields("HomeID").Value = id then
             homel = homel + 1
           else
             roadl = roadl + 1
           end if
           if rs.Fields("Conference").Value = 1 then
             afcl = afcl + 1
           else
             nfcl = nfcl + 1
           end if
           if rs.Fields("Conference").Value = team("conference") and _
              rs.Fields("Division").Value = team("division") then
             divl = divl + 1
           end if
         end if
         if rs.Fields("VisitorID").Value = id then
           pf = pf + rs.Fields("VisitorScore").Value
           pa = pa + rs.Fields("HomeScore").Value
           if rs.Fields("Division").Value = team("division") then
             netd = netd + rs.Fields("VisitorScore").Value - rs.Fields("HomeScore").Value
           end if
         else
           pf = pf + rs.Fields("HomeScore").Value
           pa = pa + rs.Fields("VisitorScore").Value
           if rs.Fields("Division").Value = team("division") then
             netd = netd + rs.Fields("HomeScore").Value - rs.Fields("VisitorScore").Value
           end if
         end if
         rs.MoveNext
       loop
     end if

     'Find and format winning percentage.

     n = w + l + t
     if n > 0 then
       pct = (w + t / 2) / n
     end if
     pct = FormatNumber(pct, 3, true)

     'Format records.

     home = homew & "-" & homel
     if homet <> 0 then
       home = home & "-" & homet
     end if
     road = roadw & "-" & roadl
     if roadt <> 0 then
       road = road & "-" & roadt
     end if
     afc = afcw & "-" & afcl
     if afct <> 0 then
       afc = afc & "-" & afct
     end if
     nfc = nfcw & "-" & nfcl
     if nfct <> 0 then
       nfc = nfc & "-" & nfct
     end if
     div = divw & "-" & divl
     if divt <> 0 then
       div = div & "-" & divt
     end if

     'Find current win/loss streak.

     strk = ""
     n = 0
     done = false
     sql = "select * from Schedule" _
        & " where Result <> ''" _
        & " and (" _
        & "  VisitorID = '" & id & "'" _
        & "  or" _
        & "  HomeID = '" & id & "')" _
        & " order by Date desc"
     set rs = DbConn.Execute(sql)
     if not (rs.BOF and rs.EOF) then
       if rs.Fields("Result").Value = id then
         strk = "W"
       else
         strk = "L"
       end if
       do while not rs.EOF and not done
         if (strk = "W" and rs.Fields("Result").Value = id)  or _
            (strk = "L" and rs.Fields("Result").Value <> id) then
           n = n + 1
         else
           done = true
         end if
         rs.MoveNext
       loop
       strk = strk & n
     end if

     'Set team data.

     team.Add "won",  w
     team.Add "lost", l
     team.Add "tied", t
     team.Add "pct",  pct
     team.Add "pf",   pf
     team.Add "pa",   pa
     team.Add "home", home
     team.Add "road", road
     team.Add "afc",  afc
     team.Add "nfc",  nfc
     team.Add "div",  div
     team.Add "strk", strk
     team.Add "oppw", oppw
     team.Add "oppl", oppl
     team.Add "oppt", oppt
     team.Add "netd", netd
     team.Add "tb",   ""

     'Return team object.

     set TeamObj = team

   end function

   '---------------------------------------------------------------------------
   ' AddOpponent(list, id): Adds the given team 'id' to the array 'list'. Used
   ' to build a list of opponents for each team object.
   '---------------------------------------------------------------------------

   sub AddOpponent(list, id)

     dim n

     n = UBound(list)
     Redim Preserve list(n + 1)
     list(n + 1) = id

   end sub

   '---------------------------------------------------------------------------
   ' SortTeams(first, last): Used on the global team object array to sort the
   ' items within the given range based on team records and tie-breakers (where
   ' applicable). See individual tie-breaker subroutines below.
   '---------------------------------------------------------------------------

   sub SortTeams(first, last)

     dim i, j, tmp
     dim n, same, tie

     if last <= first then
       exit sub
     end if

     'Sort based on overall record.

     for i = first to last - 1
       for j = i + 1 to last
         if teams(j)("pct") > teams(i)("pct") then
           set tmp = teams(i)
           set teams(i) = teams(j)
           set teams(j) = tmp
         end if
       next
     next

     'Apply tie breakers to any teams with the same record (but only after the
     'given week.

     if CurrentWeek() >= TIE_BREAKER_MIN_WEEK then
       for i = first to last - 1
         same = true
         tie = false
         n = teams(i)("pct")
         j = i + 1
         do while (j <= last and same)
           if teams(j)("pct") = n then
             tie = true
             j = j + 1
           else
             same = false
           end if
         loop
         if tie then
           call ApplyTiebreaker1(i, j - 1)
         end if
       next
     end if

   end sub

   '---------------------------------------------------------------------------
   ' Divisional Tiebreaker #1: Best head-to-head record.
   '---------------------------------------------------------------------------
   sub ApplyTieBreaker1(first, last)

     dim n1, n2
     dim i, j
     dim w, l, t

     'Two teams, head-to-head.

     if last - first = 1 then
       n1 = CountMatches(teams(first)("oppw"), teams(last)("id"))
       n2 = CountMatches(teams(last)("oppw"), teams(first)("id"))
       if n1 <> n2 then
         if n2 > n1 then
           set tmp = teams(first)
           set teams(first) = teams(last)
           set teams(last) = tmp
         end if
         teams(first)("tb") = "Beat " & teams(last)("name") & " head-to-head."
         teams(last)("tb") = ""
       else
         call ApplyTiebreaker2(first, last)
       end if

     'Three or more teams, head-to-head.

     else
       for i = first to last
         w = 0
         l = 0
         t = 0
         for j = first to last
           if i <> j then
             w = w + CountMatches(teams(i)("oppw"), teams(j)("id"))
             l = l + CountMatches(teams(i)("oppl"), teams(j)("id"))
             t = t + CountMatches(teams(i)("oppt"), teams(j)("id"))
           end if
           if w = 0 and l = 0 and t = 0 then
             call ApplyTiebreaker2(first, last)
           end if
         next
         teams(i)("tb") = CalcPct(w & "-" & l & "-" & t)
       next
       call SortByTB(first, last)
       if teams(first)("tb") > teams(first + 1)("tb") then
         call ApplyTiebreaker1(first + 1, last)
         teams(first)("tb") = "Better head-to-head record against "
         for i = first + 1 to last
           teams(first)("tb") = teams(first)("tb") & teams(i)("name") & ", "
           teams(i)("tb") = ""
         next
         teams(first)("tb") = Left(teams(first)("tb"), Len(teams(first)("tb")) - 2) & "."
       elseif teams(first)("tb") = teams(first + 1)("tb") and _
              teams(first)("tb") > teams(first + 2)("tb") then
         call ApplyTiebreaker1(first, first + 1)
         call ApplyTiebreaker1(first + 2, last)
       else
         call ApplyTiebreaker2(first, last)
       end if

     end if

   end sub  

   '---------------------------------------------------------------------------
   ' Divisional Tiebreaker #2: Best record in division.
   '---------------------------------------------------------------------------
   sub ApplyTieBreaker2(first, last)

     dim n1, n2
     dim i, j
     dim w, l, t

     'Two teams, division records.

     if last - first = 1 then
       n1 = CalcPct(teams(first)("div"))
       n2 = CalcPct(teams(last)("div"))
       if n1 <> n2 then
         if n2 > n1 then
           set tmp = teams(first)
           set teams(first) = teams(last)
           set teams(last) = tmp
         end if
         teams(first)("tb") = "Better division record than " & teams(last)("name") & "."
         teams(last)("tb") = ""
       else
          call ApplyTiebreaker3(first, last)
       end if

     'Three or more teams, division records.

     else
       for i = first to last
         teams(i)("tb") = CalcPct(teams(i)("div"))
       next
       call SortByTB(first, last)
       if teams(first)("tb") > teams(first + 1)("tb") then
         call ApplyTiebreaker1(first + 1, last)
         teams(first)("tb") = "Better division record than "
         for i = first + 1 to last
           teams(first)("tb") = teams(first)("tb") & teams(i)("name") & ", "
           teams(i)("tb") = ""
         next
         teams(first)("tb") = Left(teams(first)("tb"), Len(teams(first)("tb")) - 2) & "."
       elseif teams(first)("tb") = teams(first + 1)("tb") and _
              teams(first)("tb") > teams(first + 2)("tb") then
         call ApplyTiebreaker1(first, first + 1)
         call ApplyTiebreaker1(first + 2, last)
       else
         call ApplyTiebreaker3(first, last)
       end if

     end if

   end sub  

   '---------------------------------------------------------------------------
   ' Divisional Tiebreaker #3: Best record in conference.
   '---------------------------------------------------------------------------
   sub ApplyTieBreaker3(first, last)

     dim n1, n2
     dim i, j
     dim conf

     'Determine conference.

     if teams(first)("conference") = 1 then
       conf = "afc"
     else
       conf = "nfc"
     end if

     'Two teams, conference records.

     if last - first = 1 then
       n1 = CalcPct(teams(first)(conf))
       n2 = CalcPct(teams(last)(conf))
       if n1 <> n2 then
         if n2 > n1 then
           set tmp = teams(first)
           set teams(first) = teams(last)
           set teams(last) = tmp
         end if
         teams(first)("tb") = "Better conference record than " & teams(last)("name") & "."
         teams(last)("tb") = ""
       else
         call ApplyTiebreaker4(first, last)
       end if

     'Three or more teams, conference records.

     else
       for i = first to last
         teams(i)("tb") = CalcPct(teams(i)(conf))
       next
       call SortByTB(first, last)
       if teams(first)("tb") > teams(first + 1)("tb") then
         call ApplyTiebreaker1(first + 1, last)
         teams(first)("tb") = "better conference record than "
         for i = first + 1 to last
           teams(first)("tb") = teams(first)("tb") & teams(i)("name") & ", "
           teams(i)("tb") = ""
         next
         teams(first)("tb") = Left(teams(first)("tb"), Len(teams(first)("tb")) - 2) & "."
       elseif teams(first)("tb") = teams(first + 1)("tb") and _
              teams(first)("tb") > teams(first + 2)("tb") then
         call ApplyTiebreaker1(first, first + 1)
         call ApplyTiebreaker1(first + 2, last)
       else
         call ApplyTiebreaker4(first, last)
       end if

     end if

   end sub  

   '---------------------------------------------------------------------------
   ' Divisional Tiebreaker #4: Best record in common games.
   '---------------------------------------------------------------------------
   sub ApplyTieBreaker4(first, last)

     dim i, j
     dim list, c
     dim w, l, t

     'Find common games.

     list = ""
     for i = 0 to UBound(teams)
       found = true
       for j = first to last
         c = CountMatches(teams(j)("oppw"), teams(i)("id")) _
           + CountMatches(teams(j)("oppl"), teams(i)("id")) _
           + CountMatches(teams(j)("oppt"), teams(i)("id"))
         if c = 0 then
           found = false
         end if
       next
       if found then
         if list = "" then
           list = teams(i)("id")
         else
           list = list & "," & teams(i)("id")
         end if
       end if
     next
     list = Split(list, ",")

     'Get winning percentage in common games.

     for i = first to last
       w = 0
       l = 0
       t = 0
       for j = 0 to UBound(list)
         w = w + CountMatches(teams(i)("oppw"), list(j))
         l = l + CountMatches(teams(i)("oppl"), list(j))
         t = t + CountMatches(teams(i)("oppt"), list(j))
       next
       teams(i)("tb") = CalcPct(w & "-" & l & "-" & t)
     next
     call SortByTB(first, last)

     'Two teams, common games.

     if last - first = 1 then
       if teams(first)("tb") > teams(last)("tb") then
         teams(first)("tb") = "Better record in common games than " & teams(last)("name") & "."
         teams(last)("tb") = ""
       else
         call ApplyTiebreaker5(first, last)
       end if

     'Three or more teams, common games.

     else
       if teams(first)("tb") > teams(first + 1)("tb") then
         call ApplyTiebreaker1(first + 1, last)
         teams(first)("tb") = "Better record in common games than "
         for i = first + 1 to last
           teams(first)("tb") = teams(first)("tb") & teams(i)("name") & ", "
           teams(i)("tb") = ""
         next
         teams(first)("tb") = Left(teams(first)("tb"), Len(teams(first)("tb")) - 2) & "."
       elseif teams(first)("tb") = teams(first + 1)("tb") and _
              teams(first)("tb") > teams(first + 2)("tb") then
         call ApplyTiebreaker1(first, first + 1)
         call ApplyTiebreaker1(first + 2, last)
       else
         call ApplyTiebreaker5(first, last)
       end if

     end if

   end sub  

   '---------------------------------------------------------------------------
   ' Divisional Tiebreaker #5: Net points in division games.
   '---------------------------------------------------------------------------
   sub ApplyTieBreaker5(first, last)

     dim i, j

     'Sort teams by net points in division games.

     for i = first to last
       teams(i)("tb") = teams(i)("netd")
     next
     call SortByTB(first, last)

     'Two teams, net points in division games.

     if last - first = 1 then
       if teams(first)("tb") > teams(last)("tb") then
         teams(first)("tb") = "More net points in division games than " & teams(last)("name") & "."
         teams(last)("tb") = ""
       else
         call ApplyTiebreaker6(first, last)
       end if

     'Three or more teams, net points in division games.

     else
       if teams(first)("tb") > teams(first + 1)("tb") then
         call ApplyTiebreaker1(first + 1, last)
         teams(first)("tb") = "More net points in division games than "
         for i = first + 1 to last
           teams(first)("tb") = teams(first)("tb") & teams(i)("name") & ", "
           teams(i)("tb") = ""
         next
         teams(first)("tb") = Left(teams(first)("tb"), Len(teams(first)("tb")) - 2) & "."
       elseif teams(first)("tb") = teams(first + 1)("tb") and _
              teams(first)("tb") > teams(first + 2)("tb") then
         call ApplyTiebreaker1(first, first + 1)
         call ApplyTiebreaker1(first + 2, last)
       else
         call ApplyTiebreaker6(first, last)
       end if

     end if

   end sub  

   '---------------------------------------------------------------------------
   ' Divisional Tiebreaker #6: Net points in all games.
   '---------------------------------------------------------------------------
   sub ApplyTieBreaker6(first, last)

     dim i, j

     'Sort teams by net points in all games.

     for i = first to last
       teams(i)("tb") = teams(i)("pf") - teams(i)("pa")
     next
     call SortByTB(first, last)

     'Two teams, net points in all games.

     if last - first = 1 then
       if teams(first)("tb") > teams(last)("tb") then
         teams(first)("tb") = "More net points in all games than " & teams(last)("name") & "."
         teams(last)("tb") = ""
       else
         call ApplyTiebreaker7(first, last)
       end if

     'Three or more teams, net points in all games.

     else
       if teams(first)("tb") > teams(first + 1)("tb") then
         call ApplyTiebreaker1(first + 1, last)
         teams(first)("tb") = "More net points in all games than "
         for i = first + 1 to last
           teams(first)("tb") = teams(first)("tb") & teams(i)("name") & ", "
           teams(i)("tb") = ""
         next
         teams(first)("tb") = Left(teams(first)("tb"), Len(teams(first)("tb")) - 2) & "."
       elseif teams(first)("tb") = teams(first + 1)("tb") and _
              teams(first)("tb") > teams(first + 2)("tb") then
         call ApplyTiebreaker1(first, first + 1)
         call ApplyTiebreaker1(first + 2, last)
       else
         call ApplyTiebreaker7(first, last)
       end if

     end if

   end sub  

   '---------------------------------------------------------------------------
   ' Divisional Tiebreaker #7: Strength of schedule.
   '---------------------------------------------------------------------------
   sub ApplyTieBreaker7(first, last)

     dim i, j
     dim list, id
     dim w, l, t

     'Sort teams by opponents winning percentage.

     for i = first to last
       list = Array()
       for each id in teams(i)("oppw")
         if CountMatches(list, id) = 0 then
           call AddOpponent(list, id)
         end if
       next
       for each id in teams(i)("oppl")
         if CountMatches(list, id) = 0 then
           call AddOpponent(list, id)
         end if
       next
       for each id in teams(i)("oppt")
         if CountMatches(list, id) = 0 then
           call AddOpponent(list, id)
         end if
       next
       w = 0
       l = 0
       t = 0
       for each id in list
         for j = 0 to UBound(teams)
           if teams(j)("id") = id then
             w = w + teams(j)("won")
             l = l + teams(j)("lost")
             t = t + teams(j)("tied")
           end if
         next
       next
       teams(i)("tb") = CalcPct(w & "-" & l & "-" & t)
     next
     call SortByTB(first, last)

     'Two teams, strength of schedule.

     if last - first = 1 then
       if teams(first)("tb") > teams(last)("tb") then
         teams(first)("tb") = "Strength of schedule better than " & teams(last)("name") & "."
         teams(last)("tb") = ""
       else
         teams(first)("tb") = "Unable to determine tie breaker"
         teams(last)("tb") = ""
       end if

     'Three or more teams, strength of schedule.

     else
       if teams(first)("tb") > teams(first + 1)("tb") then
         call ApplyTiebreaker1(first + 1, last)
         teams(first)("tb") = "Strength of schedule better than "
         for i = first + 1 to last
           teams(first)("tb") = teams(first)("tb") & teams(i)("name") & ", "
           teams(i)("tb") = ""
         next
         teams(first)("tb") = Left(teams(first)("tb"), Len(teams(first)("tb")) - 2) & "."
       elseif teams(first)("tb") = teams(first + 1)("tb") and _
              teams(first)("tb") > teams(first + 2)("tb") then
         call ApplyTiebreaker1(first, first + 1)
         call ApplyTiebreaker1(first + 2, last)
       else
         teams(first)("tb") = "Unable to determine tiebreaker."
         for i = first + 1 to last
           teams(i)("tb") = ""
         next
       end if

     end if

   end sub  

   '---------------------------------------------------------------------------
   ' CountMatches(list, x): Returns the number of occurences of value 'x' in
   ' array 'list'.
   '---------------------------------------------------------------------------

   function CountMatches(list, x)

     dim i

     CountMatches = 0
     for i = 0 to UBound(list)
       if list(i) = x then
         CountMatches = CountMatches + 1
       end if
     next

   end function

   '---------------------------------------------------------------------------
   ' CalcPct(rec): Calculates a winning percentage where the string 'rec' is
   ' in either 'W-L' or 'W-L-T' format. For example, "10-5" returns .667 and
   ' "5-7-1" returns .385
   '---------------------------------------------------------------------------

   function CalcPct(rec)

     dim list, w, l, t, n

     CalcPct = 0
     list = Split(rec, "-")
     if UBound(list) < 1 then
       exit function
     end if
     w = CInt(list(0))
     l = CInt(list(1))
     if UBound(list) = 2 then
       t = CInt(list(2))
     else
       t = 0
     end if
     n = w + l + t
     if n > 0 then
       CalcPct = (w + t / 2) / n
     end if

   end function

   '---------------------------------------------------------------------------
   ' SortByTB(first, last): Sorts the global list of teams within the given
   ' range based on whatever value is currently in their tie-breaker fields.
   '---------------------------------------------------------------------------

   sub SortByTB(first, last)

     dim i, j, tmp

     if last <= first then
       exit sub
     end if

     for i = first to last - 1
       for j = i + 1 to last
         if teams(j)("tb") > teams(i)("tb") then
           set tmp = teams(i)
           set teams(i) = teams(j)
           set teams(j) = tmp
         end if
       next
     next

   end sub %>
