<%@ LANGUAGE="VBScript" %>

<% '***************************************************************************
   '* Football Pool                                                           *
   '*                                                                         *
   '* Copyright 2000 by Mike Hall                                             *
   '* Web address: http://www.brainjar.com                                    *
   '*                                                                         *
   '* Use permitted provided this notice remains intact. Any sale or redis-   *
   '* tribution without prior consent is prohibited.                          *
   '***************************************************************************
%>

<!-- #include file="protect.inc" -->
<!-- #include file="common.inc" -->
<!-- #include file="header.inc" -->

<% found = false

   'Open the database.

   call OpenDB()

   'Create an array of user objects.

   dim users
   n = NumberOfUsers()
   redim users(n - 1)

   sql = "select *" _
      & " from Users" _
      & " where Username <> '" & ADMIN_USERNAME & "'" _
      & " order by Username"
   set rs = DbConn.Execute(sql)
   if not (rs.EOF and rs.BOF) then
     i = 0
     do while not rs.EOF
       set users(i) = UserObj(rs.Fields("Username").Value)
       i = i + 1
       rs.MoveNext
     loop
   end if

   'List the winners for each week.

   first = true
   for i = 1 to NumberOfWeeks()
     list = WinnersList(i)
     if IsArray(list) then
       if first then
         first = false %>
<span class="default"><b>Weeky Winners</b></span>
<p>
<table bgcolor="#000066" border=0 cellpadding=1 cellspacing=0><tr><td>
<table bgcolor="#ffffff" border=0 cellpadding=3 cellspacing=0 width="100%">
<tr>
  <th class="right">Week&nbsp;</th>
  <th>Winner&nbsp;</th>
  <th>Score&nbsp;</th>
  <th class="right">TB Diff.&nbsp;</th>
  <th class="right">Players&nbsp;</th>
  <th class="right">Pot&nbsp;</th>
</tr>
<%     end if
       if Round(i / 2) * 2 <> i then %>
<tr>
<%     else %>
<tr class="alt">
<%     end if
       entries = NumberOfEntries(i)
       score = UserScore(list(0), i)
       games = NumberOfGames(i)
       pct = FormatPercent(score / games)
       diff = Abs(TBPointTotal(i) - UserTBGuess(list(0), i))
       pot = BET_AMOUNT * entries
       str = ""
       for j = 0 to UBound(list)

         'Update total winnings for users in the winning list.

         for k = 0 to UBound(users)
           numWinners = Ubound(list) + 1
           if users(k)("name") = list(j) and numWinners <> 0 then
             users(k)("won") = users(k)("won") + 1 / numWinners
             users(k)("winnings") = users(k)("winnings") + pot / numWinners
           end if
         next

         'Build a string listing the names of all the week's winners.

         if j > 0 then
           str = str & ", "
         end if
         str = str & list(j)
       next %>
  <td align=right><% = i %>&nbsp;</td>
  <td><% = str %>&nbsp;</td>
  <td align=right><% = score %>/<% = games %> (<% = pct %>)&nbsp;</td>
  <td align=right><% = diff %>&nbsp;</td>
  <td align=right><% = entries %>&nbsp;</td>
  <td align=right><% = FormatAmount(pot) %>&nbsp;</td>
</tr>
<%   end if
   next
   if not first then %>
</table>
</td></tr></table>
<p>
<% end if

   'Display individual statistics.

   if n = 0 then
     call ErrorMessage("No users found in database.")
   else %>
<span class="default"><b>Individual Statistics</b></span>
<p>
<table bgcolor="#000066" border=0 cellpadding=1 cellspacing=0><tr><td>
<table bgcolor="#ffffff" border=0 cellpadding=3 cellspacing=0 width="100%">
<tr>
  <th>Name</th>
  <th class="right">Played&nbsp;</th>
  <th class="right">Won</th>
  <th class="right">Cost&nbsp;</th>
  <th class="right">Winnings&nbsp;</th>
  <th class="right">Total&nbsp;</th>
  <th class="right" colspan=2>Overall Picks</th>
</tr>
<%   'List summary data for each player.

     for i = 0 to UBound(users)
       if Round(i / 2) * 2 = i then %>
<tr>
<%       else %>
<tr class="alt">
<%       end if
         cost =  users(i)("played") * BET_AMOUNT
         total = users(i)("winnings") - cost
         if users(i)("games") <> 0 then
           pct = "(" & FormatPercent(users(i)("correct") / users(i)("games")) & ")"
         else
           pct = ""
         end if %>
  <td><% = users(i)("name") %>&nbsp;</td>
  <td align=right><% = users(i)("played") %>&nbsp;</td>
  <td align=right><% = users(i)("won") %>&nbsp;</td>
  <td align=right><% = FormatAmount(cost) %>&nbsp;</td>
  <td align=right><% = FormatAmount(users(i)("winnings")) %>&nbsp;</td>
  <td align=right><% = FormatAmount(total) %>&nbsp;</td>
  <td align=right><% = users(i)("correct") & "/" & users(i)("games") %>&nbsp;</td>
  <td align=right><% = pct %>&nbsp;</td>
</tr>
<%   next %>
</table>
</td></tr></table>
<p>
<% end if %>

<!-- #include file="footer.inc" -->

<% '***************************************************************************
   '* Local functions and subroutines.                                              *
   '***************************************************************************

   '---------------------------------------------------------------------------
   ' UserObj(username): Creates a dictionary object to hold data for an
   ' individual user.
   '---------------------------------------------------------------------------

   function UserObj(username)

     dim sql, rs
     dim user, week

     set user = Server.CreateObject("Scripting.Dictionary")
     user.Add "name", username

     'Find the number of weeks this user has participated in. Count entries
     'only up to the last week with game results.

     user.Add "played", 0
     sql = "select max(week) as last" _
        & " from Schedule" _
        & " where Result <> ''"
     set rs = DbConn.Execute(sql)
     if not (rs.BOF and rs.EOF) then
       week = rs.Fields("last").Value
       sql = "select count(*) as total" _
          & " from TieBreaker" _
          & " where Username = '" & username & "'" _
          & " and Week <= " & week
       set rs = DbConn.Execute(sql)
       if not (rs.BOF and rs.EOF) then
         user("played") = rs.Fields("total").Value
       end if
     end if

     'Find the number of correct picks this user has made for all games played.

     user.Add "correct", 0
     sql = "select count(*) as total" _
        & " from Picks, Schedule" _
        & " where Username = '" & username & "'" _
        & " and Picks.GameID = Schedule.GameID" _
        & " and Picks.Pick = Schedule.Result" _
        & " and Schedule.Result <> ''"
     set rs = DbConn.Execute(sql)
     if not (rs.BOF and rs.EOF) then
       user("correct") = rs.Fields("total").Value
     end if

     'Find the total number of picks this user has made for all games played.

     user.Add "games", 0
     sql = "select count(*) as total" _
        & " from Picks, Schedule" _
        & " where Username = '" & username & "'" _
        & " and Picks.GameID = Schedule.GameID" _
        & " and Schedule.Result <> ''"
     set rs = DbConn.Execute(sql)
     if not (rs.BOF and rs.EOF) then
       user("games") = rs.Fields("total").Value
     end if

     'Initialize remaining fields.

     user.Add "won", 0
     user.Add "winnings", 0

     'Return user object.

     set UserObj = user

   end function %>
